# --------------------
KHz = 10 ** 3  # 1 KГц
MHz = 10 ** 6  # 1 МГц
GHz = 10 ** 9  # 1 ГГц

mks = 1e-6  # 1 мкс
# --------------------
resonance_frequency = 21.506 * GHz  # Rb 85

# МОДЕЛЬ ТАВИСА-КАММИНГСА С 2 ГРУППАМИ АТОМОВ ПО n ЭЛЕМЕНТОВ В КАЖДОЙ, ГДЕ ИЗУЧАЮТСЯ ОСЦИЛЛЯЦИИ МЕЖДУ ВОЗБУЖДЕННЫМИ СОСТОЯНИЯМИ ОДНОЙ ГРУППЫ И ДРУГОЙ
# ЛИНДБЛАД
# ВЫЧИСЛЕНИЕ И ПОСТРОЕНИЕ ГРАФИКОВ ПРОИЗВОДИТСЯ В ВЫЧИСЛИТЕЛЬНОМ БАЗИСЕ
# АТОМЫ НУМЕРУЮТСЯ, НАЧИНАЯ С 0; В БАЗИСНОМ СОСТОЯНИИ - СПРАВА НАЛЕВО
#
# capacity - полная энергия полости
# n - количество атомов в группе (общее число атомов - 2*n)
# wc - cavity frequency (Hz)
# wa - atomic transition frequency (Hz)
# g - vacuum Rabi frequency which characterizes to the photon-atom interaction strength (Hz)
#
# T - время (мкс)
# dt - временной шаг (мкс)
# nt - число шагов по времени
#
# init_state - произвольное начальное состояние
#
# Пример:
# 	capacity = 8
# 	init_state = [5, [0, 0, 0, 1, 1, 1]]
#   в полости 5 фотонов в фоковском состоянии |5>
# 	первая группа атомов |000> - в основном состоянии
# 	вторая группа атомов |111> - в возбужденном состоянии

# BEGIN--------------------------------------------------- CAVITY -----------------------------------------------------
capacity = 5
n = 10

wc = 21.506 * GHz

wa = [21.506 * GHz] * n

g = [1.0 * 1e-2 * 21.506 * GHz] * int(n / 2) + \
    [1.0 * 1e-2 * 21.506 * GHz] * int(n / 2)
# END----------------------------------------------------- CAVITY -----------------------------------------------------

# -------------------------------------------------------------------------------------------------
T = 0.05 * mks
# T = 0.1 * mks
# T = 0.25 * mks
# T = 0.5 * mks
# T = 1 * mks
# T = 5 * mks
# T = 10 * mks

# dt = T / 500
# dt = T / 1000

# nt = int(T / dt)
# -------------------------------------------------------------------------------------------------
nt = 20000

nt = int(T/mks*nt)

dt = T / nt
# -------------------------------------------------------------------------------------------------

init_state = [capacity - int(n / 2), [0] * int(n / 2) + [1] * int(n / 2)]

precision = 3

# ---------------------------------------------------------------------------------------------------------------------
# Относительные пути файлов вывода для построения графика
path = "BipartiteGeneral/out/" + str(capacity) + "_" + str(int(n/2)) + "/"
H_html = path + "H.html"
H_csv = path + "H.csv"
U_csv = path + "U.csv"
ro_0_csv = path + "ro_0.csv"
U_csv = path + "U.csv"
x_csv = path + "x.csv"
y_csv = path + "t.csv"
z_csv = path + "z.csv"
z_all_csv = path + "z_all.csv"
fid_csv = path + "fid.csv"
fid_small_csv = path + "fid_small.csv"
# ---------------------------------------------------------------------------------------------------------------------
